/*
Important note
Phones that are spawned after the map-load WILL NOT WORK, since their convos are never bound.
Only phones that are placed in the map file itself will work.
*/


class ConvoPhone extends ElectronicDevices;

struct tConvos
	{
	var() string PhoneNumber;
	var() name FlagRequired;
	var() name ConversationTag;
	var() int cost;
	};

var() tConvos Convos[32]; //these *can* be changed in UEd, but usually won't need to be
                          //it's only implemented for internal extensions, for example
                          //all numbers should be the same length

var HUDPhoneWindow phoneWin;

var() bool bBlock911; //if true, 911 calls cannot be made


var int x; //index to Convos (used for pending convo)
var DeusExPlayer pl;


function Frob(Actor Frobber, Inventory frobWith)
{
local DeusExPlayer p;
local DeusExRootWindow root;

//don't call super.frob!

if(Convos[0].PhoneNumber=="")
	return;

p=DeusExPlayer(Frobber);
if(p==None) return;

root=DeusExRootWindow(p.rootWindow);
if(root==None) return;

if(phoneWin!=None)
	{
	BroadcastMessage("phoneWin exists!");
	return;
	}

phoneWin=HUDPhoneWindow(root.InvokeUIScreen(Class'HUDPhoneWindow', True));
root.MaskBackground(True);
PhoneWin.PhoneOwner = Self;
PhoneWin.player = p;
PhoneWin.numLength=len(Convos[0].PhoneNumber);
PhoneWin.bBlock911=bBlock911;
PhoneWin.InitData();
}

function DialNum(string num,DeusExPlayer p)
{
pl=p;

//SPECIAL CASE - 911
if(num=="911")
	{
	x=-1;
	SetTimer(0.25,False);
	return;
	}

for(x=0;x<32;x++)
	{
	if(Convos[x].PhoneNumber==num)
		if(CheckFlag(Convos[x].FlagRequired) && Convos[x].ConversationTag!='None')
			{
			if(p.credits<convos[x].cost)
				p.ClientMessage("You cannot afford to make this call.");
			else
				{
				SetTimer(0.25,False);				
				}
			}
	}

//fall through
switch(Rand(2))
	{
	case 0: PlaySound(sound'PhoneBusy',SLOT_Misc); break;
	case 1: PlaySound(sound'PhoneDialtone',SLOT_Misc); break;
	}
}

function Timer()
{
if(x==-1)
	{
	pl.StartConversationByName('Phone_Emergency',self,,True);
	}
else
	{
	pl.credits-=convos[x].cost;
	pl.StartConversationByName(Convos[x].ConversationTag,self,,True);
	}
}

function bool CheckFlag(name flagName)
{
local DeusExPlayer player;
player=DeusExPlayer(GetPlayerPawn());
if(player==None) return False;
if(flagName=='None') return True;

return player.flagBase.GetBool(flagName);
}

defaultproperties
{
ItemName="Telephone"
BindName="ConvoPhone"
Mesh=LodMesh'DeusExDeco.Phone'
CollisionRadius=11.870000
CollisionHeight=3.780000
Mass=20.000000
Buoyancy=15.000000
bInvincible=True
bPushable=False
Convos(0)=(PhoneNumber="5550000",FlagRequired=None,ConversationTag=None,cost=0)
bBlock911=False
FamiliarName="Telephone"
UnfamiliarName="Telephone"
}