class ConvoRadio extends DeusExPickup;

#exec AUDIO IMPORT FILE="Sounds\Static.wav" NAME="Static" GROUP="Misc"

struct tConvos
	{
	var() string RadioFrequency;	//the frequency
	var() name FlagRequired;	//a flag which must be true in order to run convo
	var() name ConversationTag;	//the actual tag of the convo
	var() string Owner;		//owner of the convo - if they're dead, it won't play
	};

var() tConvos Convos[32]; //these *can* be changed in UEd, but usually won't need to be
 //it's only implemented for internal extensions, for example
 //all numbers should be the same length

var HUDRadioWindow radioWin;

var() bool bBlock911; //if true, 911 calls cannot be made


var int x; //index to Convos (used for pending convo)
var DeusExPlayer pl;


function Activate()
{
local DeusExPlayer p;
local DeusExRootWindow root;

if(Convos[0].RadioFrequency=="")
	return;

p=DeusExPlayer(owner);
if(p==None) return;

root=DeusExRootWindow(p.rootWindow);
if(root==None) return;

if(radioWin!=None)
	{
	BroadcastMessage("radioWin exists!");
	return;
	}

radioWin=HUDradioWindow(root.InvokeUIScreen(Class'HUDRadioWindow', True));
root.MaskBackground(True);
radioWin.RadioOwner = Self;
radioWin.player = p;
radioWin.numLength=len(Convos[0].RadioFrequency);
radioWin.InitData();
}

function DialNum(string num,DeusExPlayer p)
{
pl=p;

for(x=0;x<32;x++)
	{
	if(Convos[x].RadioFrequency==num)
		if(CheckFlag(Convos[x].FlagRequired) && Convos[x].ConversationTag!='None')
			{
			if(Convos[x].owner=="" || !CheckFlag(p.rootWindow.StringToName(Convos[x].owner$"_Dead")))
				{
				SetTimer(0.25,False);				
				return;
				}
			}
	}

//fall through
PlaySound(sound'Static',SLOT_Misc);
}

function Timer()
{
pl.StartDataLinkTransmission(String(Convos[x].ConversationTag));
}

function bool CheckFlag(name flagName)
{
local DeusExPlayer player;
player=DeusExPlayer(GetPlayerPawn());
if(player==None) return False;
if(flagName=='None') return True;

return player.flagBase.GetBool(flagName);
}

function DropFrom(vector StartLocation)
{
if(DeusExPlayer(owner)!=None)
	DeusExPlayer(owner).ClientMessage("Cannot drop the walkie-talkie.");
}

defaultproperties
{
Convos(0)=(RadioFrequency="49",FlagRequired=MeetSgtKerry_Played,ConversationTag=Radio_SgtKerry,owner="SgtKerry")

ItemName="Radio walkie-talkie"
beltDescription="RADIO"
description="A walkie-talkie. Use it to talk. While walking."
maxCopies=1
bCanHaveMultipleCopies=False
PlayerViewOffset=(X=20.000000,Y=10.000000,Z=-16.000000)
PlayerViewMesh=LodMesh'DeusExItems.MultitoolPOV'
PickupViewMesh=LodMesh'DeusExItems.Multitool'
ThirdPersonMesh=LodMesh'DeusExItems.Multitool3rd'
LandSound=Sound'DeusExSounds.Generic.PlasticHit2'
Icon=Texture'DeusExUI.Icons.BeltIconMultitool'
largeIcon=Texture'DeusExUI.Icons.LargeIconMultitool'
largeIconWidth=28
largeIconHeight=46
Mesh=LodMesh'DeusExItems.Multitool'
CollisionRadius=4.800000
CollisionHeight=0.860000
Mass=20.000000
Buoyancy=10.000000
bActivatable=True
}