class ModdedPawn extends HumanMilitary;

var() bool bCurrentAlly; //TRUE for NPCs I'm working for/with

var() bool bAsleep;      //if true, this pawn appears to be asleep

var() name BestAlliance; //this should probably be the same for all pawns. set it to your long-term ally's alliance.

var float AsleepTimer;

//reduce damage
function TakeDamage(int Damage, Pawn instigatedBy, Vector hitlocation, Vector momentum, name damageType)
{
if(bImportant && bCurrentAlly) //important people take less damage
	Damage*=0.3;

Super.TakeDamage(Damage,instigatedBy,hitLocation,momentum,damageType);
}

function Died(pawn Killer, name damageType, vector HitLocation)
{
local DeusExPlayer p;
local ScriptedPawn pwn;

p=DeusExPlayer(GetPlayerPawn());

Super.Died(Killer,damageType,HitLocation);

if(Killer==p && bCurrentAlly && Alliance==BestAlliance)
	{
	p.FlagBase.SetBool('PlayerKilledGoodAlly',True,,0); //set flag

	foreach AllActors(class'ScriptedPawn',pwn) //make allies evil
		if(/*pwn.GetPawnAllianceType(self)==ALLIANCE_Friendly && */pwn.Alliance==Alliance)
			pwn.ChangeAlly('Player',-1.0,True,True);
	}	
}


function PlayBodyThud()
{
if(!bAsleep)
	Super.PlayBodyThud();
}

state Idle
{
ignores bump, frob, reacttoinjury;
	function BeginState()
	{
	StandUp();
	BlockReactions(true);
	bCanConverse = False;
	SeekPawn = None;
	EnableCheckDestLoc(false);
	if(bAsleep)
		{
		AsleepTimer=2.0;
		PlayAnim('Falling',10,0.1);
		}
	}
	function EndState()
	{
	ResetReactions();
	bCanConverse = True;
	}
	function Tick(float deltaTime)
	{
	if(AsleepTimer>0)
		{
		AsleepTimer-=1.0;
		PlayAnim('Falling',10,0.1);
		}
	Super.Tick(deltaTime);
	}

Begin:
Acceleration=vect(0,0,0);
DesiredRotation=Rotation;
//PlayAnimPivot('Still');
PlayAnimPivot('Asleep');

Idle:
}

//tweaked so folk tend to fall off roofs when they die.
state Dying
{
ignores SeePlayer, EnemyNotVisible, HearNoise, KilledBy, Trigger, Bump, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, WarnTarget, Died, Timer, TakeDamage;

	//perform traces around the dying guy, to see which direction goes furthest down
	function BeginState()
	{
	local Vector HitLocation,HitNormal;
	local Vector TraceStart,TraceEnd;
	local float dist;

	local Vector biggestDropPoint;
	local float  biggestDropSize;

	local Rotator rot;
	local int scale;

	biggestDropPoint=location;
	biggestDropSize=CollisionHeight;

	rot.pitch=0;
	rot.roll=0;

	for(rot.Yaw=0;rot.Yaw<65536 && biggestDropSize<1024;rot.Yaw+=1024)
		for(scale=1;scale<=4 && biggestDropSize<1024;scale++)
			{
			TraceStart=Location+Vector(rot)*CollisionRadius*scale;
			TraceEnd=TraceStart;
			TraceEnd.Z-=1024;

			//do a trace. if we don't hit anything, it's a LOOOONG way down so assume it's the furthest
			if(Trace(HitLocation,HitNormal,TraceEnd,TraceStart,True)==None)
				{
				biggestDropPoint=TraceStart;
				biggestDropSize=1024;
				}
			else
				{
				dist=Location.Z-HitLocation.Z;
				if(dist<0) dist=-dist;

				if(dist>biggestDropSize)
					{
					biggestDropPoint=TraceStart;
					biggestDropSize=dist;
					}
				}
			}

	if(biggestDropSize>CollisionHeight)
		{
		SetRotation(rotator(Location-biggestDropPoint));
		SetLocation(biggestDropPoint);
		}


	Super.BeginState();
	}

Begin:
	WaitForLanding();
	MoveFallingBody();

	DesiredRotation.Pitch = 0;
	DesiredRotation.Roll  = 0;

	// if we don't gib, then wait for the animation to finish
	if ((Health > -100) && !IsA('Robot'))
		FinishAnim();

	SetWeapon(None);

	bHidden = True;

	Acceleration = vect(0,0,0);
	SpawnCarcass();
	Destroy();
}


defaultproperties
{
bCurrentAlly=False
BestAlliance='UNATCO'
}